ghc-9.6.3: The GHC API

Safe Haskell | Safe-Inferred
Language | Haskell2010

GHC.Wasm.ControlFlow.FromCmm

Synopsis

- structuredControl :: forall expr stmt m. Applicative m => Platform -> (Label -> CmmExpr -> m expr) -> (Label -> CmmActions -> m stmt) -> CmmGraph -> m (WasmControl stmt expr '[] '['I32])

# Documentation

structuredControl Source #

Arguments

:: forall expr stmt m. Applicative m |
=> Platform | needed for offset calculation
-> (Label -> CmmExpr -> m expr) | translator for expressions
-> (Label -> CmmActions -> m stmt) | translator for straight-line code
-> CmmGraph | CFG to be translated
-> m (WasmControl stmt expr '[] '['I32]) |

Convert a Cmm CFG to WebAssembly's structured control flow.